// this script contains the actions and functions that will be used in the first level
///////////////////////////////////////////////////////////////////////////////////////////

font figures_font = <font.tga>, 15, 15;
font score_font = <scorefont.pcx>, 15, 15; // same font with a blueish touch


///////////////////////////////////////////////////////////////////////////////////////////

function move_asteroid();
function destroy_asteroid();
function fire_rocket();
function move_rocket();
function remove_rocket();
function explode_me();
function particle_trail();
function fade_particles();
function player_was_hit();
function particle_smoke();

///////////////////////////////////////////////////////////////////////////////////////////

define ammo skill21;
define shield skill22;

///////////////////////////////////////////////////////////////////////////////////////////

var track_handle = 0; // sound handle for the music track in level1
var ready_to_play = 0; // will be set to 1 when the player can start to play
var score_value = 0; // will be converted to a string and displayed on the screen
var player_is_dead = 0;
var media_handle;
var temp_var; // just a temporary variable
///////////////////////////////////////////////////////////////////////////////////////////

string asteroid1_mdl = <asteroid1.mdl>;
string asteroid2_mdl = <asteroid2.mdl>;
string asteroid3_mdl = <asteroid3.mdl>;
string rocket_mdl = <rocket.mdl>;

string explo13_pcx = <explo+9.pcx>;

string score_str = "00000000";
string temp_str; // just a temporary string

///////////////////////////////////////////////////////////////////////////////////////////

sound engage_wav = <engage.wav>;
sound rocket_wav = <rocket.wav>;
sound destroyed_wav = <destroyed.wav>;
sound hit_wav = <hit.wav>;

///////////////////////////////////////////////////////////////////////////////////////////

bmap shield_tga = <shield.tga>;
bmap ammo_tga = <ammo.tga>;
bmap ptrail_tga = <ptrail.tga>;

bmap smoke_tga = <smoke.tga>;

///////////////////////////////////////////////////////////////////////////////////////////

text timex 
{
	font = "figures_font#32b";
	string("Time:"); 
	pos_x = 0; 
	pos_y = 0;
}


panel time_pan 
{		
digits(0, 0, 15, figures_font#32b, 1, sec);
}

panel shield_pan
{
	bmap = shield_tga;
	layer = 10;
	pos_x = 950;
	pos_y = 720;
	digits = 7, 15, 3, figures_font, 1, player.shield;
	flags = overlay, refresh, visible;
}

panel ammo_pan
{
	bmap = ammo_tga;
	layer = 10;
	pos_x = 0;
	pos_y = 555;
	digits = 12, 15, 3, figures_font, 1, player.ammo;
	flags = overlay, refresh, transparent;
}


panel damage_pan
{
	bmap = damage.bmp;
	layer = 30;
	pos_x = 0;
	pos_y = 0;
	flags = overlay, refresh;
}

panel wrecked_pan
{
	bmap = wrecked.bmp;
	layer = 30;	
	pos_x = 288;
	pos_y = 282;
	flags = transparent, overlay, refresh;
}

panel gameover_pan
{
	bmap = gameover.bmp;
	layer = 30;	
	pos_x = 288;
	pos_y = 282;
	flags = transparent, overlay, refresh;
}

panel crosshair_pan
{
	bmap = pointer2_tga;
	layer = 20;	
	pos_x = 368;
	pos_y = 282;
	flags = transparent, overlay, refresh;
}


panel score_pan
{
	bmap = score.tga;
	layer = 10;	
	pos_x = 300;
	pos_y = 5;
	flags = overlay, refresh, visible;
}


text score_txt 
{ 
	pos_x = 380; 
	pos_y = 5; 
	layer = 10;
	font = score_font; 
	string = score_str;
	flags = visible;
} 

///////////////////////////////////////////////////////////////////////////////////////////

function clock_counter()
{	
while(min>=0&&sec>0)
{
sec-=1;	
wait(-1);
if(sec==0)
{
freeze_mode = 1;
mouse_mode = 2;
sec = 0;
gameover_pan.visible = on;
crosshair_pan.visible = off;
wait(-5);
menu_load();	
}
}
}

function menu_load()
{

mouse_mode = 2;
media_stop(media_handle);
main_pan.visible = on;
damage_pan.visible = off;
wrecked_pan.visible = off;
gameover_pan.visible = off;
crosshair_pan.visible = off;

}

action planet_level1 // attached to the "planet" (a flat mdl, really)
{
	my.passable = on;
	fog_color = 1; // orange fog
	camera.clip_far = 1000000; // works only with A6, delete this line if you own A5
	camera.z = -100; // play with this value
	camera.fog_start = 50; // start drawing the fog close to the camera
	camera.fog_end = 20000; // close to the level boundary
	while (ready_to_play == 0) // shift the texture with this speed until the game starts
	{
		my.v += 3 * time;
		wait (1);
	}
	my.z -= 5000;
	my.ambient = 30;
	while (player_is_dead == 0) // now shift with this speed until the player is dead
	{
		my.v += 2 * time; // slow down the movement a bit
		wait (1);
	}
}

sky my_cube 
{ 
	type = <skycube+6.tga>;
	layer = 5; 
	flags = cube, visible; 
} 







action sky_level1
{
my.ambient = 0;
}

action player_level1
{
	player = my; // I'm the player
	my.ammo = 8000;
	my.shield = 100;
	my.metal = on;
	my.ambient = 100;
	my.transparent = on;
	my.alpha = 100;
	my.enable_impact = on;
	my.enable_entity = on;
	my.event = player_was_hit;
	vec_set(temp, player.x); // rotate the camera towards player's ship from the very beginning
	vec_sub(temp, camera.x); 
	vec_to_angle(camera.pan, temp); 
   media_loop ("track1.wav", null, 100); // play the sound track
	sleep (0.5); // wait a bit before starting the ship
	fade_factor = 1000; // destroy the engine particles instantly (the ship has a huge speed now)
	my.engine = on;
	plasma_jet(65, 63); // use the "real" set of vertices for the engine now (we needed to use a different set of vertices for the top view)
	while (my.x < 3000)
	{
		my.roll += 1.5 * time;
		ent_playsound (my, engine1_wav, 300); // play the same engine sound that was used for the menu
		my.x += 52 * time;
		vec_set(temp, my.x); // rotate the camera towards player's ship all the time
		vec_sub(temp, camera.x); 
		vec_to_angle(camera.pan, temp); 
		wait (1);
	}
	ready_to_play = 1; // get rid of the sky and give control to the player
	my.x = -10000;
	my.y = 0;
	my.z = -100;
	my.roll = 0;

	crosshair_pan.visible = on;
	camera.x = -10230;
	camera.y = 0;
	camera.z = -50;
	camera.pan = 0;
	camera.tilt = 0;
	camera.fog_start = 15000;
	camera.fog_end = 40000;

	fade_factor = 1000; // destroy the engine particles quickly (the ship has a small speed now)
	snd_play (engage_wav, 70, 0);	// the player can take control of the ship now
	while (my.shield > 0)
	{
		camera.pan %= 360; // keep camera.pan in this range: 0...359
		camera.tilt += 10 * mouse_force.y * time;
		camera.pan -= 10 * mouse_force.x * time;
		if ((camera.pan > 30) && (camera.pan < 330)) // don't allow the player to blow our cover (if it looks back)
		{
			if (camera.pan < 180) 
			{
				camera.pan = 30;
			}
			else 
			{
				camera.pan = 330;
			}
		}
		if (camera.tilt < -35)
		{
			camera.tilt = -35;
		}
		if (camera.tilt > 25)
		{
			camera.tilt = 25;
		}
		my.pan = camera.pan;	
		my.tilt = camera.tilt;

		vec_set (temp_var, my.pos); // copy player's position to temp_var
		vec_to_screen(temp_var, camera); // now temp_var contains the 2D position (x, y) of the ship
		if ((abs(temp_var.x - 400) < 50) || (abs(temp_var.y - 300) < 40)) // the crosshair and the ship tend to overlap?
		{
			my.alpha = (abs(temp_var.x - 400) + abs(temp_var.y - 300));
		}
		else
		{
			if (my.alpha < 99)
			{
				my.alpha += 0.5 * time;
			}
		}

		if ((mouse_left == 1) && (player.ammo > 0))
		{
			fire_rocket();
		}

		if ((key_a == on) && (my.y < 100))
		{
			my.y += 10 * time;
			if (my.roll < 30)
			{
				my.roll += 3 * time;
			}
		}
		if ((key_d == on) && (my.y > -100))
		{
			my.y -= 10 * time;
			if (my.roll > -30)
			{
				my.roll -= 3 * time;
			}
		}
		if (key_a + key_d == 0)
		{
			if (my.roll > 1)
			{
				my.roll -= 1 * time;
			}
			if (my.roll < -1)
			{
				my.roll += 1 * time;
			}
		}
		if (key_p == on)
		{
			freeze_mode = 1;
		}
	   if (key_o == on)
		{
			freeze_mode = 0;
		}
		wait (1);
	}
	// the player is dead here
	sec = 0;
	wrecked_pan.visible = on;
	crosshair_pan.visible = off;
	wait(-5);
   menu_load();
	camera.pan = 0;
	camera.tilt = -10;
	while (my.z > -1990) // come close to the planet
	{
		if (camera.tilt > -30) {camera.tilt -= 0.2 * time;}
		my.x += 30 * time;
		my.z -= 20 * time;
		my.roll += 10 * time;
		wait (1);
	}
	player_is_dead = 1; // stop the texture shifting for the planet
	my.skill10 = 10; // create a big explosion sprite for player's ship
	ent_create (explo13_pcx, my.pos, explode_me);
	my.tilt = -50; // choose a weird position for the ship
	my.passable = on;
	ent_playsound (my, hit_wav, 5000);
	fade_factor = 2;
	while (1)
	{
		temp.x = 3 - random(6);
		temp.y = 3 - random(6);
		temp.z = 4 + random(4);
		effect(particle_smoke, 10, my.pos, temp);
		wait (1);
	}		
}

action asteroid_maker
{
	var temp_var;
	my.passable = on;
	my.invisible = on;
	while (1)
	{
		temp.x = my.x;
		temp.y = 5000 - random(10000); // -5,000 to 5,000
		temp.z = 1000 - random(2000);
		if (ready_to_play == 0) // game not started yet?
		{
			if ((temp.y > -500) && (temp.y < 500)) // the asteroid is too close to the player during the cut scene?
			{
				temp.y = 500; // then avoid the player until it is able to control the ship
			}
		}
		temp_var = random(1);
		if (temp_var < 0.33)
		{
			ent_create (asteroid1_mdl, temp, move_asteroid);
		}
		if ((temp_var >= 0.33) && (temp_var < 0.66))
		{
			ent_create (asteroid2_mdl, temp, move_asteroid);
		}
		if (temp_var > 0.66)
		{
			ent_create (asteroid3_mdl, temp, move_asteroid);
		}
		wait (2);
	}
}

function move_asteroid()
{
	var meteor_angle;
	var meteor_speed;
	my.enable_impact = on;
	my.enable_entity = on;
	my.event = destroy_asteroid;
	my.scale_x = 5 + random(15);
	my.scale_y = my.scale_x;
	my.scale_z = my.scale_x;
	my.skill10 = my.scale_x; // store the scale in skill10 - we will use it to adjust the size of the explosion later
	meteor_angle.x = 3 - random(6); // random pan speed
	meteor_angle.y = 3 - random(6); // random tilt speed
	meteor_angle.z = 3 - random(6); // random roll speed
	meteor_speed.x = (-100 - random(80)) * time;
	meteor_speed.y = 0;
	meteor_speed.z = 0;
	while (my.x > -21000)
	{
		my.pan += meteor_angle.x * time;
		my.tilt += meteor_angle.y * time;
		my.roll += meteor_angle.z * time;
		move_mode = ignore_you + ignore_passable;
		ent_move (nullvector, meteor_speed);
		wait (1);
	}
	sleep (1);
	ent_remove (my);
}

function destroy_asteroid()
{
	if (you.skill40 == 1234) // hit by player's rocket?
	{
		score_value += int(1000 / (my.skill10 + 1)); // get bigger scores for smaller asteroids
	}
	my.x = -30000; // get out of the while loop inside function move_asteroid() and create a nice effect for the cut scene
	wait (1);
	my.event = null;
	ent_create (explo13_pcx, my.pos, explode_me);
	my.passable = on;
	my.invisible = on;
	ent_playsound (my, hit_wav, 1000);
	sleep (2); // wait until function explode_me reads the value stored in skill10 and until the sound is played
	ent_remove(my); // now remove it
}

function explode_me()
{
	
	my.flare = on;
	my.bright = on;
	my.ambient = random(100);
	my.passable = on;
	my.roll = random(360); // pick a random orientation
	my.skill30 = you.skill10; // store skill10 quickly because "you" will be removed soon
	while (my.frame < 14)
	{
		if (my.scale_x < my.skill30) // grow until you reach the value that was stored or set in skill10
		{
			my.scale_x += 5 * time;
			my.scale_y = my.scale_x;
		}
		my.frame += 1 * time;

		vec_set (temp.x, camera.x);
		vec_sub (temp.x, my.x);
		vec_to_angle (my.pan, temp); // turn towards the player to make sure that the explo looks great

		wait (1);
	}
	ent_remove (me);
}

function fire_rocket()
{
	proc_kill(4); // only one instance of this function is running
	while (mouse_left == 1) {wait (1);} 
	player.ammo -= 1;
	ent_create (rocket_mdl, player.pos, move_rocket);
	snd_play (rocket_wav, 200, 0);
}

function move_rocket()
{
	wait (1);
	my.enable_entity = on;
	my.enable_block = on;
	my.event = remove_rocket;
	my.pan = camera.pan;
	my.tilt = camera.tilt;
	my.skill40 = 1234; // I'm a rocket
	my.skill10 = 3; // default explosion scale for the rocket
	my.skill20 = 0;
	while (my.skill20 < 500)
	{
		my.skill1 = 500 * time;
		my.skill2 = 0;
		my.skill3 = 0;
		my.skill20 += 1 * time;
		ent_move (my.skill1, nullvector);

		temp.x = my.x;
		temp.y = my.y;
		temp.z = my.z;
		effect (particle_trail, 1, temp, normal);
		wait (1);
	}
	remove_rocket();
}

function particle_trail()
{
	temp.x = 100;
	temp.y = 0;
	temp.z = 0;
	vec_rotate (temp, you.pan); // use the same orientation with the rocket
	vec_add (my.vel_x, temp);
	my.alpha = 70 + random(30);
	my.bmap = ptrail_tga;
	my.size = 7;
	my.flare = on;
	my.bright = on;
	my.beam = on; // comment this line if your engine can't use "beam"
	my.move = on;
	my.lifespan = 30;
	my.function = fade_particles;
}

function fade_particles()
{
	my.alpha -= 100 * time;
	if (my.alpha < 0) {my.lifespan = 0;}
}

function remove_rocket()
{
	wait (1);
	my.event = null;
	ent_playsound (my, destroyed_wav, 1000); // play the explosion sound
	ent_create (explo13_pcx, my.pos, explode_me);
	my.invisible = on; // hide the rocket, keep ent_playsound playing
	sleep (2); // for 2 more seconds
	ent_remove(me); // now remove it
}

function player_was_hit()
{
	damage_pan.visible = on;
	my.event = null; // stop reacting to events for now
	my.shield -= you.skill10 * 1.5; // bigger asteroids cause greater damage
	if (my.shield < 0) {my.shield = 0;}
	my.skill33 = 0;
	snd_play (hit_wav, 100, 0);
	if (player.shield > 0) // the game isn't over yet?
	{
		while (my.skill33 < 10)
		{
			camera.roll = 2 - random(4); // shake the player a bit
			my.skill33 += 1 * time;
			wait (1);
		}
		player.roll = 0; // then restore player's roll
	}
	my.event = player_was_hit;
}

function particle_smoke()
{
	my.alpha = 40 + random(50);
	my.bmap = smoke_tga;
	my.bright = on;
	my.flare = on;
	my.move = on;
	my.beam = on; // if your engine supports it
	my.size = 30;
	my.function = particle_fade; // use the same particle_fade function that was used for the plasma jets
}

starter compute_score()
{
	while (1)
	{
		str_for_num(temp_str, score_value); // convert the value to string
		if (str_len(temp_str) == 1)
		{
			str_cpy(score_str, "0000000");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 2)
		{
			str_cpy(score_str, "000000");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 3)
		{
			str_cpy(score_str, "00000");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 4)
		{
			str_cpy(score_str, "0000");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 5)
		{
			str_cpy(score_str, "000");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 6)
		{
			str_cpy(score_str, "00");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 7)
		{
			str_cpy(score_str, "0");
			str_cat(score_str, temp_str);
		}
		if (str_len(temp_str) == 8)
		{
			str_cat(score_str, temp_str);
		}
		wait (1);
	}
}
